//index.js
const express = require('express');
const cors = require('cors');
const app = express();
const mysql = require('mysql2/promise'); // Use mysql2/promise for promise-based queries
//const bcrypt = require('bcrypt');
const router = require('./router');
const chatApiRouter = require('./chat_api'); // Import the chat_api router
const session = require('express-session');
const crypto = require('crypto');
const isAuthenticated = require('./isAuthenticated');
// Use cors middleware
app.use(cors());
app.use(express.json());
const secret = crypto.randomBytes(32).toString('hex');
app.use(session({
    secret: secret,
    resave: true,
    saveUninitialized: true // You can set it to false if you don't want to save uninitialized sessions
}));
console.log('secret',secret);
app.use('/dalaba/api_controller', router());
// app.use('/dashboardController', router());
// app.use('/guestUserController', router());
// app.use('/vipUserController', router());
// app.use('/contentController', router());
// app.use('/updateContentController', router());
// app.use('/topPostController', router());
// app.use('/localPostController', router());
// app.use('/keywordController', router());
// app.use('/keywordAddController', router());
// app.use('/getKeywordNameController', router());
// app.use('/keywordEditController', router());
// app.use('/keywordDeleteController', router());
// app.use('/getAvatarController', router());
// app.use('/userActiveDeactiveController', router());
// app.use('/addVIPUserController', router());
app.use(chatApiRouter);

const port = 3000;
app.listen(port, () => {
    console.log(`Server is running at http://localhost:${port}`);
});
