const OpenAI = require("openai");
const openai = new OpenAI({
  apiKey: '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',
});
const assistantId ='asst_q7jLuXZfWx7XE8LC79e6YCED';
const express = require('express');
const app = express();
app.use(express.json()); // Parse JSON bodies
const connection = require('./db');
const multer = require('multer');
const router = express.Router();
const upload = multer(); // Initialize multer


// Endpoint to add a user
router.post('/chat_api', upload.none(), async (req, res) => {
  try {
    const domain = req.body.domain;
    let thread_id = req.body.thread_id;
    const question = req.body.question;
    

    // create thread if empty
    if (!thread_id) {
      const myThread = await openai.beta.threads.create();
      thread_id = myThread.id; // Store the generated thread ID
    }
    // create messages
    const myThreadMessage = await openai.beta.threads.messages.create(
      (thread_id = thread_id),
      {
        role: "user",
        content: question,
        //file_ids: [fileId,fileId1],
      }
    );
    console.log("This is the message object: ", myThreadMessage, "\n");

    // Run the Assistant
    const myRun = await openai.beta.threads.runs.create(
      (thread_id = thread_id),
      {
        assistant_id: assistantId,
        //instructions: question,
      }
    );
    console.log("This is the run object: ", myRun, "\n");

    // Step 6: Periodically retrieve the Run to check on its status to see if it has moved to completed
  const retrieveRun = async () => {
    let keepRetrievingRun;

    while (myRun.status === "queued" || myRun.status === "in_progress") {
      keepRetrievingRun = await openai.beta.threads.runs.retrieve(
        (thread_id = thread_id),
        (run_id = myRun.id)
      );
      console.log(`Run status: ${keepRetrievingRun.status}`);

      if (keepRetrievingRun.status === "completed") {
        console.log("\n");

        // Step 7: Retrieve the Messages added by the Assistant to the Thread
        const allMessages = await openai.beta.threads.messages.list(
          (thread_id =thread_id)
        );

        console.log(
          "------------------------------------------------------------ \n"
        );
        
        console.log("User: ", myThreadMessage.content[0].text.value);
        console.log("Assistant: ", allMessages.data[0].content[0].text.value);
        const assistantResponse = allMessages.data[0].content[0].text.value;

        // Check if the thread already exists
    const threadCheckQuery = 'SELECT thread_id FROM thread_master WHERE thread = ?';
    connection.query(threadCheckQuery, [thread_id], (error, threadCheckResults, threadCheckFields) => {
      if (error) {
        throw error;
      }

      if (threadCheckResults.length > 0) {
        // If the thread exists, retrieve the thread_id
        const existingThreadId = threadCheckResults[0].thread_id;

        // Retrieve the user_id based on the existing thread_id
        const userQuery = 'SELECT user_id FROM thread_master WHERE thread_id = ?';
        connection.query(userQuery, [existingThreadId], (error, userResults, userFields) => {
          if (error) {
            throw error;
          }

          // Retrieve the user_id
          const user_id = userResults[0].user_id;

          // Proceed with other operations or return the existing data
          res.status(200).json({ user_id, thread_id: existingThreadId });

          // Insert into ques_ans_master
          const quesAnsInsertQuery = 'INSERT INTO ques_ans_master (question, answer, createtime, updatetime) VALUES (?, ?, NOW(), NOW())';
          connection.query(quesAnsInsertQuery, [question, assistantResponse], (error, quesAnsResults, quesAnsFields) => {
            if (error) {
              throw error;
            }

            // Retrieve the ques_ans_id after insertion
            const insertedQuesAnsID = quesAnsResults.insertId;

            // Rest of your code...
            console.log('Ques_Ans ID (after insertion):', insertedQuesAnsID);
          });
        });
      } else {
        // The thread does not exist, proceed with the insertion

        // Check if the domain already exists
        const checkQuery = 'SELECT user_id FROM chat_user_master WHERE domain = ?';
        connection.query(checkQuery, [domain], (error, results, fields) => {
          if (error) {
            throw error;
          }

          if (results.length > 0) {
            // If the domain exists, retrieve the user_id
            const user_id = results[0].user_id;

            // Insert into thread_master
            const threadInsertQuery = 'INSERT INTO thread_master (user_id, thread, createtime, updatetime) VALUES (?, ?, NOW(), NOW())';
            connection.query(threadInsertQuery, [user_id, thread_id], (error, threadResults, threadFields) => {
              if (error) {
                throw error;
              }

              // Retrieve the thread_id after insertion
              const insertedThreadID = threadResults.insertId;

              // Insert into ques_ans_master
              const quesAnsInsertQuery = 'INSERT INTO ques_ans_master (question, answer, createtime, updatetime) VALUES (?, ?, NOW(), NOW())';
              connection.query(quesAnsInsertQuery, [question, assistantResponse], (error, quesAnsResults, quesAnsFields) => {
                if (error) {
                  throw error;
                }

                // Retrieve the ques_ans_id after insertion
                const insertedQuesAnsID = quesAnsResults.insertId;

                // Rest of your code...
                res.status(200).json({question: question, assistantResponse: assistantResponse });
              });
            });
          } else {
            // If the domain does not exist, insert it into the table with createtime
            const userInsertQuery = 'INSERT INTO chat_user_master (domain, createtime) VALUES (?, NOW())';

            connection.query(userInsertQuery, [domain], (error, userResults, userFields) => {
              if (error) {
                throw error;
              }

              // Retrieve the user_id after insertion
              const user_id = userResults.insertId;

              // Insert into thread_master
              const threadInsertQuery = 'INSERT INTO thread_master(user_id, thread, createtime, updatetime) VALUES (?, ?, NOW(), NOW())';
              connection.query(threadInsertQuery, [user_id, thread_id], (error, threadResults, threadFields) => {
                if (error) {
                  throw error;
                }

                // Retrieve the thread_id after insertion
                const insertedThreadID = threadResults.insertId;

                // Insert into ques_ans_master
                const quesAnsInsertQuery = 'INSERT INTO ques_ans_master (question, answer, createtime, updatetime) VALUES (?, ?, NOW(), NOW())';
                connection.query(quesAnsInsertQuery, [question, assistantResponse], (error, quesAnsResults, quesAnsFields) => {
                  if (error) {
                    throw error;
                  }

                  // Retrieve the ques_ans_id after insertion
                  const insertedQuesAnsID = quesAnsResults.insertId;

                  // Rest of your code...
                  res.status(200).json({question: question, assistantResponse: assistantResponse});
                });
              });
            });
          }
        });
      }
    });

        break;
      } else if (
        keepRetrievingRun.status === "queued" ||
        keepRetrievingRun.status === "in_progress"
      ) {
        // pass
      } else {

        console.log(`Run status: ${keepRetrievingRun.status}`);
        if (keepRetrievingRun.status === "failed") {
          console.error("Run failed:", keepRetrievingRun.last_error);
          // Handle the error or return an appropriate response
          res.status(500).json({ error: "Run failed" });
          return;
        }
        
        break;
      }
    }
  };
  retrieveRun();

    

  } catch (error) {
    console.error('Error processing chat_api:', error);
    res.status(500).json({ error: 'Internal server error' });
  }
});

// Start the server
module.exports = router;
