// content.js

const express = require('express');

const router = express.Router();

const connection = require('./db');

const languageMessages = require('./language_messages');



const initController = () => {

  router.get('/get_content', async (req, res) => {

    try {

      const query = 'SELECT content_id, content_type, content,content_1 FROM content_master WHERE delete_flag = 0';

      connection.query(query, [0], (error, rows) => { // Pass parameters in an array

        if (error) {

          console.error('Error executing MySQL query:', error);

          return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

        }



        let contentArr = []; // Declare contentArr outside of the if block



        // Check if any rows were returned

        if (rows.length > 0) {

          contentArr = rows.map(row => ({

            content_id: row.content_id,

            content_type: row.content_type,

            content: row.content,
            content_1: row.content_1

          }));

        } else {

          contentArr = 'NA';

        }



        const record = { success: true, msg: languageMessages.msgDataFound[0], data: contentArr };

        res.json(record);

      });

    } catch (error) {

      console.error('Error executing MySQL query:', error);

      res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

    }

  });



  return router;

};



module.exports = initController;

