// Import necessary modules
//keywordDeleteController.js
const express = require('express');
const multer = require('multer');
const crypto = require('crypto');
const router = express.Router();
const connection = require('./db');
const languageMessages = require('./language_messages'); // Import language messages
//console.log('login');
router.use(express.json());
router.use(express.urlencoded({ extended: true }));
const upload = multer();
router.use(upload.none());
// Route to handle editing keywords
const initController = () => {
  router.post('/delete_contact_us', async (req, res) => {
    try {
      // Validate keyword and avatar_id
      const contact_id = req.body.contact_id;
   
      // Update keyword in the database
      const query = 'UPDATE contact_us_master SET delete_flag = 1, updatetime = NOW() WHERE contact_id=?'; // Assuming 'keyword_master' is your table name
      connection.query(query, [contact_id], (error, results) => {
        if (error) {
          console.error('Error updating keyword:', error);
          return res.status(200).json({ success: false, msg: languageMessages.errorDeleteContactUs[0] });
        }
        return res.status(200).json({ success: true, msg: languageMessages.contactUsDeleteSuccessfully[0] });
      });
    } catch (error) {
      console.error('Error updating keyword:', error);
      return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
    }
  });
  return router;
};
module.exports = initController;
