// Import necessary modules
//keywordDeleteController.js
const express = require('express');
const multer = require('multer');
const crypto = require('crypto');
const router = express.Router();
const connection = require('./db');
const languageMessages = require('./language_messages'); // Import language messages
//console.log('login');
router.use(express.json());
router.use(express.urlencoded({ extended: true }));
const upload = multer();
router.use(upload.none());
// Route to handle editing keywords
const initController = () => {
  router.post('/delete_vip_user', async (req, res) => {
    try {
      // Validate keyword and avatar_id
      const user_id = req.body.user_id;
   
      // Update keyword in the database
      const query = 'UPDATE user_master SET delete_flag = 1, updatetime = NOW() WHERE user_id=?'; // Assuming 'keyword_master' is your table name
      connection.query(query, [user_id], (error, results) => {
        if (error) {
          console.error('Error updating keyword:', error);
          return res.status(500).json({ success: false, msg: languageMessages.errorDeleteUser[0] });
        }
        return res.status(200).json({ success: true, msg: languageMessages.userDeleteSuccessfully[0] });
      });
    } catch (error) {
      console.error('Error updating keyword:', error);
      return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
    }
  });
  return router;
};
module.exports = initController;
