//get_admin_manage_count.js
const express = require('express');
const router = express.Router();
const connection = require('./db');
const languageMessages = require('./language_messages');


const initController = () => {
    router.get('/get_admin_manage_count', async (req, res) => {
        try {
            const userQuery = 'SELECT manage_id, post_like_count, post_dislike_count, local_post_count, post_show_km,post_show_miles,home_top_count,home_local_count,post_disappear_delete_day,top_post_show_km,top_post_show_miles,top_post_disappear_delete_day,min_word,max_word,guest_account_delete,top_post_fee_usd,top_post_fee_yuan,latitude,longitude,completely_delete_post FROM admin_manage_master WHERE delete_flag = 0';
            connection.query(userQuery, (error, countResult) => {
                if (error) {
                    console.error('Error fetching admin manage count:', error);
                    return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
                }

                // Construct the response based on whether data is found or not
                if (countResult.length === 0) {
                    // If no data is found, send an empty array
                    const record = { success: true, msg: languageMessages.msgDataFound[0], data: { count_detail: [] } };
                    return res.json(record);
                } else {
                    // If data is found, construct the response with the retrieved data
                    const record = { success: true, msg: languageMessages.msgDataFound[0], data: { count_detail: countResult[0] } };
                    res.json(record);
                }
            });
        } catch (error) {
            console.error('Error in get_admin_manage_count endpoint:', error);
            res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
        }
    });

    return router;
};

module.exports = initController;
