//getkeywordnamebyid.js

const express = require('express');

const router = express.Router();

const connection = require('./db');

const languageMessages = require('./language_messages');

const { decodeUserId } = require('./common_function');







const initController = () => {

    router.get('/get_admin_profile', async (req, res) => {

      try {

        const user_id = req.query.user_id;

   

        const userQuery = 'SELECT user_id, name,email,image,username,account_fund_balance,account_currency FROM user_master WHERE user_id = ? AND delete_flag = 0'; // Update the SQL query to filter by keyword_id

        connection.query(userQuery, [user_id], (error, detailResult) => {

          if (error) {

            console.error('Error executing MySQL query:', error);

            return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

          }

          

          // Check if any keyword is found

          if (detailResult.length === 0) {

            return res.status(404).json({ success: false, msg: 'Keyword not found' });

          }

          

          const admin_detail = detailResult[0]; // Get the first (and only) keyword from the result

          

          const record = { success: true, msg: 'Keyword found', data: { admin_detail } };

          res.json(record);

        });

      } catch (error) {

        console.error('Error executing MySQL query:', error);

        res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

      }

    });

  

    return router;

  };

  

  module.exports = initController;

