//getAllkeywordnamebyuserid.js

const express = require('express');

const router = express.Router();

const connection = require('./db');

const languageMessages = require('./language_messages');



const initController = () => {

    router.get('/get_all_guest_user', async (req, res) => {

        try {


            const userQuery = 'SELECT user_id, username FROM user_master WHERE delete_flag = 0 and profile_complete=1 and user_type=1 order by user_id desc';

            connection.query(userQuery, (error, keywordResults) => {

                if (error) {

                    console.error('Error executing MySQL query:', error);

                    return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

                }



                // Check if any keywords are found

                if (keywordResults.length === 0) {

                    return res.status(404).json({ success: false, msg: 'No users found for the user' });

                }



                // Extract keyword names from the results

                const user_detail = keywordResults.map(result => ({ user_id: result.user_id, username: result.username }));



                const record = { success: true, msg: 'Users found', data: { user_detail } };

                res.json(record);

            });

        } catch (error) {

            console.error('Error executing MySQL query:', error);

            res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

        }

    });



    return router;

};



module.exports = initController;

