//getAllkeywordnamebyuserid.js

const express = require('express');

const router = express.Router();

const connection = require('./db');

const languageMessages = require('./language_messages');



const initController = () => {

    router.get('/get_all_keyword', async (req, res) => {

        try {

            const user_id = req.query.user_id;



            const userQuery = 'SELECT keyword_id, keyword FROM keyword_master WHERE user_id = ? AND delete_flag = 0 order by keyword_id desc';

            connection.query(userQuery, [user_id], (error, keywordResults) => {

                if (error) {

                    console.error('Error executing MySQL query:', error);

                    return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

                }



                // Check if any keywords are found

                if (keywordResults.length === 0) {

                    return res.status(404).json({ success: false, msg: 'No keywords found for the user' });

                }



                // Extract keyword names from the results

                const keyword_names = keywordResults.map(result => ({ keyword_id: result.keyword_id, keyword: result.keyword }));



                const record = { success: true, msg: 'Keywords found', data: { keyword_names } };

                res.json(record);

            });

        } catch (error) {

            console.error('Error executing MySQL query:', error);

            res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

        }

    });



    return router;

};



module.exports = initController;

