const express = require('express');
const router = express.Router();
const connection = require('./db');
const languageMessages = require('./language_messages');
const {encodeUserId} = require('./common_function');


// Function to format date
function formatDate(dateString) {
  const date = new Date(dateString);
  const options = { day: '2-digit', month: '2-digit', year: 'numeric', hour: '2-digit', minute: '2-digit', hour12: true };
  const formattedDate = date.toLocaleString('en-US', options);
  return formattedDate;
}


const initController = () => {
  router.
  get('/get_avatar', async (req, res) => {
    try {
      const userQuery = 'SELECT avatar_id,avatar_image,createtime FROM avatar_master WHERE delete_flag = 0 order by avatar_id desc';
      connection.query(userQuery, async (error, userResults) => {
        if (error) {
          console.error('Error executing MySQL query:', error);
          return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
        }
        
        try {
          
        const avatar_arr = userResults.map((user, index) => {
            return {
              ...user,
              sr_no: index + 1,
              createtime: formatDate(user.createtime),
              action_html: `<div class="btn-group">
                  <button type="button" class="btn btn-primary dropdown-toggle float-button-light" id="primary-dropdown-outline" data-toggle="dropdown" aria-expanded="false">
                      Action
                  </button>
                  <ul class="dropdown-menu dropdown-menu-primary" style="margin: 2px -56px 0;" aria-labelledby="primary-dropdown" role="menu">
                  <li><a class="dropdown-item" href="edit_avatar.html?id=${encodeUserId(user.avatar_id)}"><i class="fa fa-edit"></i> Edit</a></li>
                  <li><a class="dropdown-item" onclick="deleteAvatar(${(user.avatar_id)})"><i class="fa fa-trash"></i>Delete</a></li> 
                  </ul>
              </div>`,
              image_html : `<img  width="50px" src="../webservice/images/${(user.avatar_image)}" class="rounded-circle circle-border m-b-md img-fix img-responsive" name="profile_image" id="previewholder" style="width: 70px; height: 70px;" onerror="this.src='assets/images/placeholder.png';">`
            };
        });
      
        const record = { success: true, msg: languageMessages.msgDataFound[0], data: { avatar_arr } };
        res.json(record);
        } catch (error) {
          console.error('Error fetching user details:', error);
          res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
        }
      });
    } catch (error) {
      console.error('Error executing MySQL query:', error);
      res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
    }
  });

  return router;
};

module.exports = initController;
