//getkeywordnamebyid.js

const express = require('express');

const router = express.Router();

const connection = require('./db');

const languageMessages = require('./language_messages');

const { decodeUserId } = require('./common_function');







const initController = () => {

    router.get('/get_avatar_image', async (req, res) => {

      try {

        const encodedKeywordId = req.query.avatar_id;



    // Decode the encoded avatar_id

    const avatarId = decodeUserId(encodedKeywordId);

        const userQuery = 'SELECT avatar_id, avatar_image FROM avatar_master WHERE avatar_id = ? AND delete_flag = 0'; // Update the SQL query to filter by keyword_id

        connection.query(userQuery, [avatarId], (error, keywordResult) => {

          if (error) {

            console.error('Error executing MySQL query:', error);

            return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

          }
          // Check if any keyword is found

          if (keywordResult.length === 0) {

            return res.status(404).json({ success: false, msg: 'Avatar not found' });

          }

          

          const avatar_detail = keywordResult[0]; // Get the first (and only) keyword from the result

          

          const record = { success: true, msg: 'Avatar found', data: { avatar_detail } };

          res.json(record);

        });

      } catch (error) {

        console.error('Error executing MySQL query:', error);

        res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

      }

    });

  

    return router;

  };

  

  module.exports = initController;

