//getkeywordnamebyid.js
const express = require('express');
const router = express.Router();
const connection = require('./db');
const languageMessages = require('./language_messages');
const { decodeUserId } = require('./common_function');



const initController = () => {
    router.get('/get_keyword_name', async (req, res) => {
      try {
        const encodedKeywordId = req.query.keyword_id;

    // Decode the encoded keyword_id
    const keywordId = decodeUserId(encodedKeywordId);
        const userQuery = 'SELECT keyword_id, keyword FROM keyword_master WHERE keyword_id = ? AND delete_flag = 0'; // Update the SQL query to filter by keyword_id
        connection.query(userQuery, [keywordId], (error, keywordResult) => {
          if (error) {
            console.error('Error executing MySQL query:', error);
            return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
          }
          
          // Check if any keyword is found
          if (keywordResult.length === 0) {
            return res.status(404).json({ success: false, msg: 'Keyword not found' });
          }
          
          const keyword_name = keywordResult[0]; // Get the first (and only) keyword from the result
          
          const record = { success: true, msg: 'Keyword found', data: { keyword_name } };
          res.json(record);
        });
      } catch (error) {
        console.error('Error executing MySQL query:', error);
        res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
      }
    });
  
    return router;
  };
  
  module.exports = initController;
