// Import necessary modules

//keywordAddController.js

const express = require('express');

const multer = require('multer');

const crypto = require('crypto');

const router = express.Router();

const connection = require('./db');

const languageMessages = require('./language_messages'); // Import language messages

const {currentTime } = require('./site_config');

//console.log('login');

router.use(express.json());

router.use(express.urlencoded({ extended: true }));

const upload = multer();

router.use(upload.none());



// Route to handle adding keywords

const initController = () => {

router.post('/add_keyword', async (req, res) => {

    try {

        // Validate keyword

        const keyword = req.body.keyword; // Assuming keyword is sent in the request body

        const user_id = req.body.user_id;

        if (!keyword || typeof keyword !== 'string' || keyword.trim() === '') {

            return res.status(400).json({ success: false, msg: languageMessages.invalidKeyword[0] });

        }



        // Add keyword to the database

        const query = 'INSERT INTO keyword_master (keyword,user_id,createtime,updatetime) VALUES (?,?,?,?)'; // Assuming 'keywords' is your table name

        connection.query(query, [keyword,user_id,currentTime,currentTime], (error, results) => {

            if (error) {

                console.error('Error adding keyword:', error);

                return res.status(500).json({ success: false, msg: languageMessages.errorAddingKeyword[0] });

            }

            return res.status(200).json({ success: true, msg: languageMessages.keywordAddedSuccessfully[0] });

        });

    } catch (error) {

        console.error('Error adding keyword:', error);

        return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

    }

});

return router;

};



module.exports = initController;