// Import necessary modules
//keywordEditController.js
const express = require('express');
const multer = require('multer');
const crypto = require('crypto');
const router = express.Router();
const connection = require('./db');
const languageMessages = require('./language_messages'); // Import language messages
const { decodeUserId } = require('./common_function');
const {currentTime } = require('./site_config');
//console.log('login');
router.use(express.json());
router.use(express.urlencoded({ extended: true }));
const upload = multer();
router.use(upload.none());
// Route to handle editing keywords
const initController = () => {
  router.post('/edit_keyword', async (req, res) => {
    try {
      // Validate keyword and keyword_id
      const keyword = req.body.keyword;
      const encodedKeywordId = req.body.keyword_id;
      const keyword_id = decodeUserId(encodedKeywordId);
      if (!keyword || typeof keyword !== 'string' || keyword.trim() === '' || !keyword_id) {
        return res.status(400).json({ success: false, msg: languageMessages.invalidKeyword[0] });
      }
      // Update keyword in the database
      const query = 'UPDATE keyword_master SET keyword = ?, updatetime = ? WHERE keyword_id = ?'; // Assuming 'keyword_master' is your table name
      connection.query(query, [keyword,currentTime, keyword_id], (error, results) => {
        if (error) {
          console.error('Error updating keyword:', error);
          return res.status(500).json({ success: false, msg: languageMessages.errorUpdatingKeyword[0] });
        }
        return res.status(200).json({ success: true, msg: languageMessages.keywordUpdatedSuccessfully[0] });
      });
    } catch (error) {
      console.error('Error updating keyword:', error);
      return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
    }
  });
  return router;
};
module.exports = initController;
