//router.js

const express = require('express');

const signinController = require('./signinController');
const subadminSigninController = require('./subadminSigninController');

const dashboardController = require('./dashboardController');

const subadminDashboardController = require('./subadminDashboardController');

const guestUserController = require('./guestUserController');

const vipUserController = require('./vipUserController');

const vipAdminController = require('./vipAdminController');

const contentController = require('./contentController');

const websiteContentController = require('./websiteContentController');

const websiteBlogController = require('./websiteBlogController');

const websiteScreenshotController = require('./websiteScreenshotController');

const updateContentController = require('./updateContentController');

const updateWebsiteContentController = require('./updateWebsiteContentController');

const topPostController = require('./topPostController');

const subAdmintopPostController = require('./subAdmintopPostController');

const subAdminDeletePostController = require('./subAdminDeletePostController');

const subAdminLocalPostController = require('./subAdminLocalPostController');

const localPostController = require('./localPostController');

const keywordController = require('./keywordController');

const subadminkeywordController = require('./subadminkeywordController');

const keywordAddController = require('./keywordAddController');

const getKeywordNameController = require('./getKeywordNameController');

const keywordEditController = require('./keywordEditController');

const keywordDeleteController = require('./keywordDeleteController');

const getAvatarController = require('./getAvatarController');

const userActiveDeactiveController = require('./userActiveDeactiveController');

const addVIPUserController = require('./addVIPUserController');

const addUserContactUsController = require('./addUserContactUsController');

const editVIPUserController = require('./editVIPUserController');

const editGuestUserController = require('./editGuestUserController');

const getAllKeywordController = require('./getAllKeywordController');

const getSubadminAllKeywordController = require('./getSubadminAllKeywordController');

const createPostController = require('./createPostController');

const createSubadminPostController = require('./createSubadminPostController');

const editPostController = require('./editPostController');

const avatarAddController = require('./avatarAddController');

const getAdminProfileController = require('./getAdminProfileController');

const getContactUsDetailController = require('./getContactUsDetailController');

const updateAdminProfileController = require('./updateAdminProfileController');

const updateAdminPasswordController = require('./updateAdminPasswordController');

const avatarDeleteController = require('./avatarDeleteController');

const getAvatarImageController = require('./getAvatarImageController');

const editAvatarController = require('./editAvatarController');



const getGuestUserDetailController = require('./getGuestUserDetailController');
const getVIPUserDetailController = require('./getVIPUserDetailController');
const getUserTopPost = require('./getUserTopPost');
const getUserLocalPost = require('./getUserLocalPost');
const getUserKeyword = require('./getUserKeyword');
const getPostDetail = require('./getPostDetail');
const getEditPostDetail = require('./getEditPostDetail');
const adminRePostController = require('./adminRePostController');
const getPostLikes = require('./getPostLikes');
const getPostDislikes = require('./getPostDislikes');
const getPostImages = require('./getPostImages');
const getEditPostImages = require('./getEditPostImages');
const deletePostImageController = require('./deletePostImageController');
const deleteWebsiteBlogController = require('./deleteWebsiteBlogController');
const sendUserPasswordController = require('./sendUserPasswordController');
const sendReplyController = require('./sendReplyController');
const deletePostController = require('./deletePostController');
const deletePostPermanentController = require('./deletePostPermanentController');
const getAdminManageCount = require('./getAdminManageCount');
const updateAdminManageCount = require('./updateAdminManageCount');
const getGuestUserReport = require('./getGuestUserReport');
const getVIPUserReport = require('./getVIPUserReport');
const getDeletedPostController = require('./getDeletedPostController');
const getSubadminDeletedPostController = require('./getSubadminDeletedPostController');
const getPostReport = require('./getPostReport');
const getReportedPost = require('./getReportedPost');
const forgotPasswordController = require('./forgotPasswordController');
const resetPasswordController = require('./resetPasswordController');
const getAllGuestUser = require('./getAllGuestUser');
const getAllVIPUser = require('./getAllVIPUser');
const getAllUserContactUs = require('./getAllUserContactUs');
const deleteVipUser = require('./deleteVipUser');
const deleteContactUsController = require('./deleteContactUsController');
const adminUpdateLatLong = require('./adminUpdateLatLong');


const router = express.Router();



// Accept the db parameter and pass it to the controller

const initRouter = (db) => {

    router.post('/signin', signinController(db));

    router.post('/subadminsignin', subadminSigninController(db));

    router.get('/dashboard', dashboardController(db));

    router.get('/subadmindashboard', subadminDashboardController(db));

    router.get('/getGuestUser', guestUserController(db));

    router.get('/getVipUser', vipUserController(db));

    router.get('/getVipAdminUser', vipAdminController(db));

    router.get('/get_content', contentController(db));

    router.get('/get_website_content', websiteContentController(db));

    router.get('/get_website_blog', websiteBlogController(db));

    router.get('/get_website_screenshot', websiteScreenshotController(db));

    router.post('/update_content', updateContentController(db));

    router.post('/update_website_content', updateWebsiteContentController(db));

    router.get('/getTopPost', topPostController(db));

    router.get('/getSubadminTopPost', subAdmintopPostController(db));

    router.get('/getSubadminDeletePost', subAdminDeletePostController(db));

    router.get('/getSubAdminLocalPost', subAdminLocalPostController(db));


    router.get('/getLocalPost', localPostController(db));

    router.get('/getKeyword', keywordController(db));

    router.get('/getSubAdminKeyword', subadminkeywordController(db));

    router.post('/add_keyword', keywordAddController(db));

    router.get('/get_keyword_name', getKeywordNameController(db));

    router.post('/edit_keyword', keywordEditController(db));

    router.post('/delete_keyword', keywordDeleteController(db));

    router.get('/get_avatar', getAvatarController(db));

    router.post('/active_deactive', userActiveDeactiveController(db));

    router.post('/add_vip_user', addVIPUserController(db));

    router.get('/user_contact_us', addUserContactUsController(db));

    router.post('/edit_vip_user', editVIPUserController(db));

    router.post('/edit_guest_user', editGuestUserController(db));

    router.get('/get_all_keyword', getAllKeywordController(db));

    router.get('/get_subadmin_all_keyword', getSubadminAllKeywordController(db));

    router.post('/create_post', createPostController(db));

    router.post('/create_subadmin_post', createSubadminPostController(db));

    router.post('/add_avatar', avatarAddController(db));

    router.get('/get_admin_profile', getAdminProfileController(db));

    router.get('/get_contact_user_detail', getContactUsDetailController(db));

    router.post('/edit_profile', updateAdminProfileController(db));

    router.post('/edit_password', updateAdminPasswordController(db));

    router.post('/delete_avatar', avatarDeleteController(db));

    router.get('/get_avatar_image', getAvatarImageController(db));

    router.post('/edit_avatar', editAvatarController(db));

    router.get('/get_guest_user_detail', getGuestUserDetailController(db));

    router.get('/get_user_top_post', getUserTopPost(db));

    router.get('/get_user_local_post', getUserLocalPost(db));

    router.get('/get_user_keyword', getUserKeyword(db));

    router.get('/get_vip_user_detail', getVIPUserDetailController(db));

    router.get('/get_post_detail', getPostDetail(db));

    router.get('/get_edit_post_detail', getEditPostDetail(db));

    router.get('/re_post', adminRePostController(db));

    router.get('/get_post_like', getPostLikes(db));

    router.get('/get_post_dislike', getPostDislikes(db));

    router.get('/get_post_images', getPostImages(db));

    router.get('/get_edit_post_images', getEditPostImages(db));

    router.post('/delete_post_image', deletePostImageController(db));

    router.post('/delete_website_blog', deleteWebsiteBlogController(db));

    router.post('/send_user_password', sendUserPasswordController(db));

    router.post('/send_reply', sendReplyController(db));

    router.post('/edit_post', editPostController(db));

    router.post('/delete_post', deletePostController(db));

    router.post('/delete_post_permanent', deletePostPermanentController(db));

    router.get('/get_admin_manage_count', getAdminManageCount(db));

    router.post('/update_admin_manage_count', updateAdminManageCount(db));

    router.post('/get_guest_user_report', getGuestUserReport(db));

    router.post('/get_vip_user_report', getVIPUserReport(db));

    router.get('/getDeletedPost', getDeletedPostController(db));

    router.get('/getSubadminDeletedPost', getSubadminDeletedPostController(db));

    router.post('/get_post_report', getPostReport(db));

    router.post('/get_reported_post', getReportedPost(db));

    router.post('/forgot_password', forgotPasswordController(db));

    router.post('/reset_password', resetPasswordController(db));

    router.get('/get_all_guest_user', getAllGuestUser(db));

    router.get('/get_all_vip_user', getAllVIPUser(db));

    router.get('/get_user_contactus', getAllUserContactUs(db));
    
    router.post('/delete_vip_user', deleteVipUser(db));

    router.post('/delete_contact_us', deleteContactUsController(db));

    router.post('/update_admin_lat_long', adminUpdateLatLong(db));


    return router;

};







module.exports = initRouter;