const express = require('express');

const multer = require('multer');

const crypto = require('crypto');

const router = express.Router();

const connection = require('./db');

const languageMessages = require('./language_messages'); // Import language messages



//console.log('login');

router.use(express.json());

router.use(express.urlencoded({ extended: true }));

const upload = multer();

router.use(upload.none());
const { sendMail, AddVIPAccount } = require('./mailfunction.js');
const { app_name, app_logo } = require('./site_config');

const initController = () => {
    router.post('/send_user_password', async (req, res) => {
        try {
            const { user_email, password1, user_name } = req.body;
            // Check if required fields are provided
            if (!user_email || !password1 || !user_name) {
                return res.status(400).json({ success: false, msg: languageMessages.allFieldsRequired[0],'error':req.body });
            }

            // Send email notification
            const fromName = app_name;
            const subject = 'Account Credentials';
            const mailContent = `
                <p>Hello ${user_name},</p>
                <p>Please find your ${app_name} user Account Information.</p>
                <p>Username: ${user_name}</p>
                <p>Password: ${password1}</p>
                <p>Email: ${user_email}</p>
            `;
            const mailBody = AddVIPAccount({ user_email, fromName, subject, mailContent, app_logo, name: user_name });
            sendMail(user_email, fromName, subject,mailBody)
                .then(response => {
                    console.log('Email response:', response);
                    return res.status(200).json({ success: true, msg: languageMessages.msgGuestSendMailSuccess[0] });
                })
                .catch(error => {
                    console.error('Error sending email:', error);
                    return res.status(500).json({ success: false, msg: languageMessages.msgGuestSendMailError[0],'error':error });
                });
        } catch (error) {
            console.error('Error handling request:', error);
            return res.status(500).json({ success: false, msg: languageMessages.msgGuestSendMailError[0],'error':error });
        }
    });

    return router;
};

module.exports = initController;
