const express = require('express');
const router = express.Router();
const connection = require('./db');
const languageMessages = require('./language_messages');
//const isAuthenticated = require('./isAuthenticated');

const initController = () => {
    router.get('/subadmindashboard', async (req, res) => {
    try {
      // Assuming you have an isAuthenticated middleware that sets req.user with the logged-in user's data
      const user_id = req.query.userId;

      const TopPostCountQuery = 'SELECT COUNT(post_id) AS top_post_count FROM post_master WHERE delete_flag = 0 AND post_type = 0 AND user_id = ?';
      connection.query(TopPostCountQuery, [user_id], (error, [TopPostCheckResults]) => {
        if (error) {
          console.error('Error executing MySQL query:', error);
          return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0],'error1':error });
        }
        const TopPosCount = TopPostCheckResults ? TopPostCheckResults.top_post_count : 0;

        const localPostCountQuery = 'SELECT COUNT(post_id) AS local_post_count FROM post_master WHERE delete_flag = 0 AND post_type = 1 AND user_id = ?';
        connection.query(localPostCountQuery, [user_id], (error, [localPostCheckResults]) => {
          if (error) {
            console.error('Error executing MySQL query:', error);
            return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0],'error2':error });
          }
          const localPosCount = localPostCheckResults ? localPostCheckResults.local_post_count : 0;

          
            const dashboard_arr = { TopPosCount: TopPosCount, localPosCount: localPosCount};
            const record = { success: true, msg: languageMessages.msgDataFound[0], data: dashboard_arr };

            res.json(record);
          
        });
      });
    } catch (error) {
      console.error('Error executing MySQL query:', error);
      res.status(500).json({ success: false, msg: languageMessages.internalServerError[0],'error3':error });
    }
  });
  return router;
};

module.exports = initController;
