// updateContentController.js

const express = require('express');

const multer = require('multer');

const router = express.Router();

const connection = require('./db'); // Assuming you have a database connection

const languageMessages = require('./language_messages');



router.use(express.json());

router.use(express.urlencoded({ extended: true }));

const upload = multer();

router.use(upload.none());

// Middleware to parse URL-encoded form data

//router.use(express.urlencoded({ extended: true }));

const initController = () => {

router.post('/update_content', async (req, res) => {

    try {

        const { content_id, content,content_1} = req.body;



        if (!content_id || !content) {

            return res.status(400).json({ success: false, msg: "Content ID and content are required" });

        }



        // Perform the database update operation here

        const query = 'UPDATE content_master SET content = ?,content_1=? WHERE content_id = ?';

        connection.query(query, [content,content_1, content_id], (error, result) => {

            if (error) {

                console.error('Error updating content:', error);

                return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

            }



            if (result.affectedRows > 0) {

                // Content updated successfully

                return res.json({ success: true, msg: languageMessages.contentUpdated[0] });

            } else {

                // Content with the specified content_id not found

                return res.status(404).json({ success: false, msg: languageMessages.contentNotFound[0] });

            }

        });

    } catch (error) {

        console.error('Error updating content:', error);

        res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });

    }

});

return router;

};



module.exports = initController;

