// content.js
const express = require('express');
const router = express.Router();
const connection = require('./db');
const languageMessages = require('./language_messages');
const initController = () => {
  router.get('/get_website_blog', async (req, res) => {
    try {
      const query = 'SELECT website_blog_id, image, text_eng, text_chinese,createtime FROM `website_blog_master` WHERE delete_flag = 0 order by website_blog_id desc';
      connection.query(query, [0], (error, rows) => { // Pass parameters in an array
        if (error) {
          console.error('Error executing MySQL query:', error);
          return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
        }
        let contentArr = []; // Declare contentArr outside of the if block
        // Check if any rows were returned
        if (rows.length > 0) {
            contentArr = rows.map(row => ({
                website_blog_id: row.website_blog_id,
                image: row.image,
                text_eng: row.text_eng,
                text_chinese: row.text_chinese,
                createtime:row.createtime,
            }));
        }else{
          contentArr = 'NA';
        }
        const record = { success: true, msg: languageMessages.msgDataFound[0], data: contentArr };
        res.json(record);
      });
    } catch (error) {
      console.error('Error executing MySQL query:', error);
      res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
    }
  });
  return router;
};
module.exports = initController;
