// content.js
const express = require('express');
const router = express.Router();
const connection = require('./db');
const languageMessages = require('./language_messages');
const initController = () => {
  router.get('/get_website_content', async (req, res) => {
    try {
      const query = 'SELECT website_content_id, logo, apk_file, document_file, promotional_file, promotional_file_chinese, about_us, about_us_chinese, contact_us, contact_us_chinese,promotional_file_second,promotional_file_chinese_second,promotional_image,promotional_image_second,facebook_url,twitter_url,instagram_url,pinterest_url,linkedin_url FROM `website_content_master` WHERE delete_flag = 0';
      connection.query(query, [0], (error, rows) => { // Pass parameters in an array
        if (error) {
          console.error('Error executing MySQL query:', error);
          return res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
        }
        let contentArr = []; // Declare contentArr outside of the if block
        // Check if any rows were returned
        if (rows.length > 0) {
            contentArr = rows.map(row => ({
                website_content_id: row.website_content_id,
                logo: row.logo,
                apk_file: row.apk_file,
                document_file: row.document_file,
                promotional_file: row.promotional_file,
                promotional_file_chinese: row.promotional_file_chinese,
                about_us: row.about_us,
                about_us_chinese: row.about_us_chinese,
                contact_us: row.contact_us,
                contact_us_chinese: row.contact_us_chinese,
                promotional_file_second: row.promotional_file_second,
                promotional_file_chinese_second: row.promotional_file_chinese_second,
                promotional_image: row.promotional_image,
                promotional_image_second: row.promotional_image_second,
                facebook_url: row.facebook_url,
                twitter_url: row.twitter_url,
                instagram_url: row.instagram_url,
                pinterest_url: row.pinterest_url,
                linkedin_url: row.linkedin_url,
            }));
        }else{
          contentArr = 'NA';
        }
        const record = { success: true, msg: languageMessages.msgDataFound[0], data: contentArr };
        res.json(record);
      });
    } catch (error) {
      console.error('Error executing MySQL query:', error);
      res.status(500).json({ success: false, msg: languageMessages.internalServerError[0] });
    }
  });
  return router;
};
module.exports = initController;
